
#ifdef WIN32
#include <io.h>
#include <stdio.h>
#include <direct.h>
#else
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#endif

#include <stdlib.h>
#include <string.h>
#include "WinDef.h"
#include "String.h"

/* #include "Gmem.h" */

char Command[256], Par[20][64], Parms[256];
int  defaultDriver;
char defaultPath[256], WinDir[256];
char ExePath[256], exename[256];

/******************************************************************************
**  ReadLine
**
**  returns a string from the current input line: from the current point
**  to the end of line.
**
******************************************************************************/

int ReadLine(FILE *infile, char *string, int size)
{
	int     c,i;

	i = 0;
	while(( (c=getc(infile)) != EOF ) && ( c != '\n') ){
			if (c!= '\r') *(string+i++)=c;
			if (i>size-1) {
			       	*(string+i) = '\0';
                    return -i;
            }
	}
	*(string+i) = '\0';
	return i;
}

/*
	Lower character with out changes
	chinese characters.
*/
void LowerChrx(char tempx[])
{
	BOOL Chinese;

	char Lchar[] = {'a','b','c','d','e','f','g',
		             'h','i','j','k','l','m','n',
					 'o','p','q','r','s','t','u',
					 'v','w','x','y','z'};
	unsigned int j;

	Chinese = false;
	for(j=0;j<(strlen(tempx)+1);j++)
	{
		if (Chinese)
		{
			Chinese = false;
			goto next01;
		}
		if(tempx[j]<0)
		{
			Chinese = true;
			goto next01;
		}

		if(tempx[j]>='A' && tempx[j]<='Z')
						tempx[j] = Lchar[tempx[j]-'A'];
next01:;
	}
}

int Parse(char argv[])
{
	char Ctrl;
	int  i, j, count, parx;

		 strcpy(Command, "");
		 for (i =0; i<20; i++) {
				Par[i][0] = '\0';
		 }

		 if (argv[0] < 'A') return 0;	/* Skip Comment Lines */
		 if (argv[0] > 'z') return 0;

		 i = parx = 0;
		 j = strlen(argv);

         for (count = 0; count < j; count++) {
			 if (argv[count] !=' ' &&
				 argv[count] !=',' &&
				 argv[count] != 9) {
				 Command[i++] = argv[count];
			 } else {
			     goto pas1;
			 }
		 }	/* Parse Command and Parameters */

pas1:
		 Command[i] = '\0';
		 if (argv[count] !=' ' &&
			 argv[count] !=',' &&
			 argv[count] != 9) count--;

		 strcpy (Parms, argv+count);
pas11:
		 if (count >= j) return parx;

		 do {count++;} while (argv[count] == ' ' ||
							  argv[count] == ',' ||
							  argv[count] == 9);

		 if (count >= j) return parx;
		 if ((argv[count] >='A') ||
			 (argv[count] < 0) ||
			 (argv[count] >='0' && argv[count] <='9') ||
			 (argv[count] =='*') ||
			 (argv[count] =='+') ||
			 (argv[count] == '-')) {
				Par[parx][0] = argv[count];
				Ctrl = ' ';
				i = 1;
		 } else {
				Ctrl = argv[count];
				i = 0;
		 }
		 count++;
pas12:
		 if (Ctrl == ' ') {
			if (argv[count] != ' ' &&
				argv[count] != 9 &&
				argv[count] != ',' &&
				argv[count] != '\0') {
					Par[parx][i++] = argv[count++];
					goto pas12;
			}
		 } else {
			if (argv[count] != Ctrl &&
				argv[count] != '\0') {
					Par[parx][i++] = argv[count++];
					goto pas12;
			}
		 }

		 Par[parx][i] = '\0';
		 parx++;
		 if (count >= j) return parx;
		 if (parx >19) return parx;
		 goto pas11;
}

int Parsex(char argv[])
{
	char Ctrl;
	int  i, j, count, parx;

		 for (i =0; i<20; i++) {
				Par[i][0] = '\0';
		 }

		 parx = 0;
		 count = 0;
		 j = strlen(argv);
pas11:
		 if (count >= j) return parx;

		 do {count++;} while (argv[count] == ' ' ||
							  argv[count] == ',' ||
							  argv[count] == 9);
		 count--;
		if (argv[count] == ' ' ||
			argv[count] == ',' ||
			argv[count] == 9) count++;

		 if (count >= j) return parx;
		 if ((argv[count] >='A') ||
			 (argv[count] < 0) ||
			 (argv[count] >='0' && argv[count] <='9') ||
			 (argv[count] =='*') ||
			 (argv[count] =='+') ||
			 (argv[count] == '-')) {
				Par[parx][0] = argv[count];
				Ctrl = ' ';
				i = 1;
		 } else {
				Ctrl = argv[count];
				i = 0;
		 }
		 count++;
pas12:
		 if (Ctrl == ' ') {
			if (argv[count] != ' ' &&
				argv[count] != 9 &&
				argv[count] != ',' &&
				argv[count] != '\0') {
					Par[parx][i++] = argv[count++];
					goto pas12;
			}
		 } else {
			if (argv[count] != Ctrl &&
				argv[count] != '\0') {
					Par[parx][i++] = argv[count++];
					goto pas12;
			}
		 }

		 Par[parx][i] = '\0';
		 parx++;
		 if (count >= j) return parx;
		 if (parx >19) return 20;
		 goto pas11;
}
/*
	ReadLineX read in a line from file fi
	with any size, and save dynamic in
	memory block.

    Program return the address of memory
	block and pass the length by lengthx.

    This memory block must free after used.
*/
char * ReadLineX (FILE *fi, int * length)
{
	char buffer[256], * x, * y;
	int  i, lengthx, lengthy;

    x = 0;
	*(length) = 0;

	while (!feof(fi)) {
		lengthx = ReadLine(fi, buffer, 256);
		if (lengthx == 0) return x;
		lengthy = lengthx;
		if (lengthx<0) lengthx = - lengthx;
		*(length) = lengthx;

#ifdef Gmem
		x = (char *) gmem_get(length+1);
#else
		x = (char *) malloc(lengthx+1);
#endif

		strcpy(x, buffer);
		if (lengthy>0) {
			i = lengthx;
			while (i>0 && *(x+i-1) ==' ') {
				i--;
				*(x+i) = 0;
			}
			return x;
		}

		/* *lengthx = -length; */
		lengthy = lengthx;
		lengthx = 0;
		/* Record great than buffer size? */
more01: /* Read more */
		if (!feof(fi)) {
			lengthx = ReadLine(fi, buffer, 256);
			if (!lengthx) {
				*(length) = lengthy;
				return x;
			}
			if (lengthx>0) lengthy = lengthy + lengthx;
			else lengthy = lengthy - lengthx;

#ifdef Gmem
			y = (char *) gmem_get(lengthx+1);
#else
			y = (char *) malloc(lengthy+1);
#endif

    		if (y) {
    			  strcpy(y, x);
				  strcat (y, buffer);
#ifdef Gmem
				  gmem_free((unsigned long *)x);
#else
				  free((unsigned long *)x);
#endif
				  x = y;
			}
			if (lengthx<0) goto more01;
			i = lengthy;
			while (i>0 && *(x+i-1) ==' ') {
				i--;
				*(x+i) = 0;
			}
			*(length) = lengthy;
			return x;
		}
	}
	return x;
}


	/* oeؿ */
void GetDefault()
{
	int i;

#ifdef WIN32
	defaultDriver = _getdrive();
	_getdcwd(defaultDriver, defaultPath, 256);
#else
	strcpy(defaultPath, getenv ("PWD"));
#endif
	/* _fullpath( defaultPath, defaultPath, 256); */
	/* fprintf(stderr,"default path = >%s<\n",defaultPath); */
	i = strlen(defaultPath);
	if (defaultPath[i-1]!='\\')
	{
		defaultPath[i]='\\';
		defaultPath[i+1]=0x00;
	}
}


int CopyFile (char * In, char * Out)
{
	FILE   *fi, *fo;
/*	char buffer[256];  */
	char c;

	fi = fopen (In, "rt");
	if (!fi) {
		fprintf (stderr, "open >%s< error.\n", In);
		return 0;
	}

	fo = fopen (Out, "wt");
	if (!fo) {
		fprintf (stderr, "open >%s< error.\n", Out);
		return 0;
	}
	while (!feof(fi)) {
		 c = getc(fi);
/*		fprintf (fo, "%s\n", buffer); */
		 putc(c, fo);
	}
	fclose(fi);
	fclose(fo);
	return 1;
}

#ifdef WIN32
int DirExist (char * Dirx, int Build)
{
	/* long fh; */
	/* struct _finddata_t fd; */
	FILE   *fi;
	int i;
	char temp[256];

	strcpy (temp, Dirx);
	i = strlen(temp);
	if (temp[i-1]=='\\' || temp[i-1]=='/') temp[i-1] = 0;
	/*
	  Dir Exist?
	 fh = _findfirst(Dirx, &fd);
	 fh = _findfirst(temp, &fd);
	*/
	fi = fopen (temp, "rt");
	if (!fi) {
		if (!Build) return 0;
		/* (_mkdir(Dirx)) { */
		if (_mkdir(temp)) {
			fprintf (stderr, "Dir.>%s< build error.\n", Dirx);
			return 0;
		} else return 1;
	} else {
		fclose(fi);
	}

	return 1;
}
#endif

char * strrchrx(char * Strx, char x, char y)
{
	char buffer[256], *p;
	int i, j, id, chinese;

	j = strlen(Strx);
	if (j== 0) return 0;

	p = buffer;
	i = id = chinese = 0;
	strcpy (buffer, Strx);
	while(i<j) {
		if (chinese==0) {
			/* if (buffer[i]>127 || buffer[i]<0) { */
			/* if (buffer[i]>127) { */
			if (*(p+i)<0) {
				chinese++;
			} else {
				/* if (buffer[i]==x || buffer[i]==y) { */
				if (*(p+i)==x || *(p+i)==y) {
					id = i;
				}
			}
		} else
			chinese = 0;

		i++;
	}
    if (id) {
		/* if (buffer[1]==':' && */
		if (*(p+1)==':' &&
			/* (buffer[2]==x || buffer[2]==y) && */
			(*(p+2)==x || *(p+2)==y) &&
			id == 2) return 0;
		/* buffer[id] = 0; */
		*(p+id) = 0;
		return p;
	} else
		return 0;
}

#ifdef WIN32
/*
	ChkLocalDir(path name)
	return:
		1: Dir. exist
		0: Can not created
*/
int ChkLocalDir(char * tempx,  int Build)
{
	char *ptemp,temp[256];
	BOOL last;
	int i;

chkdiragain:
	last = true;
	strcpy(temp,tempx);
	i = strlen(temp)-1;
	if (temp[i]!='/' && temp[i]!='\\') {
		temp[i+1] = '/';
		temp[i+2] = 0;
	}

MkDirx:
	/* ptemp=strrchr(temp,'\\'); */
	/* ptemp=strrchr(temp,'/'); */
	ptemp=strrchrx(temp,'/','\\');
	if(ptemp) {
			/* temp[strlen(temp)-strlen(ptemp)]=0x00; */
			strcpy (temp, ptemp);
			if (_chdir(temp)) {
				/*  Not found */
				if (!Build) return 0;
				if(_mkdir(temp)) {
					/*  error */
					last = false;
					goto MkDirx;
				}
			}
			if (!last) goto chkdiragain;
				/* إߥؿ */
			return last;
		}
	/* ptemp=strrchr(temp,'/'); */
	ptemp=strrchrx(temp,'/','\\');
	if(ptemp) {
			temp[strlen(temp)-strlen(ptemp)]=0x00;
			if (_chdir(temp)) {
				/*  error */
				if(_mkdir(temp)) {
					/*  error */
					last = false;
					goto MkDirx;
				}
			}
			if (!last) goto chkdiragain;
				/* إߥؿ */
			return last;
		}
	return 0;
}
#endif

void GetWinDir()
{
	int i;

    strcpy(WinDir, getenv ("Windir"));

	i = strlen(WinDir);
	if (WinDir[i-1]!='\\')
	{
		WinDir[i]='\\';
		WinDir[i+1]=0x00;
	}
}

#ifdef WIN32
void GetExePath (char * ProName) {
	int i, j, k;

	if( _fullpath( ExePath, ProName, 256) == NULL ) {
         ExePath[0] = 0;
		 exename[0] = 0;
		 return;
	}
	j = k = strlen(ExePath);
	while (k > 0 && ExePath[k] != '\\') --k;
    for (i=k+1;i<=j;i++) {
		if (ExePath[i]=='.') {
			exename[i-k-1] = 0;
			break;
		}
		exename[i-k-1] = ExePath[i];
	}
	strcpy(exename,_strlwr(exename));
}
#endif
